--
-- Specialzare  Universal 650M
--
-- @author  Adriano
-- NU MODIFICATI FARA ACORDUL MEU
--
utb650M = {}

function utb650M.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function utb650M:load(xmlFile)
	self.numHeadLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.headLights#count"), 0);
    self.headLights = {};
    for i=1, self.numHeadLights do
        local headLightsNamei = string.format("vehicle.headLights.headLight" .. "%d", i);
        self.headLights[i] = Utils.indexToObject(self.components, getXMLInt(xmlFile, headLightsNamei .. "#index"));
        setVisibility(self.headLights[i], false);
    end;

	self.numFrontWorkLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.frontWorkLights#count"), 0);
    self.frontWorkLights = {};
    for i=1, self.numFrontWorkLights do
        local frontWorkLightsNamei = string.format("vehicle.frontWorkLights.frontWorkLight" .. "%d", i);
        self.frontWorkLights[i] = Utils.indexToObject(self.components, getXMLInt(xmlFile, frontWorkLightsNamei .. "#index"));
        setVisibility(self.frontWorkLights[i], false);
    end;
	
	self.numWorkLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.workLights#count"), 0);
    self.workLights = {};
    for i=1, self.numWorkLights do
        local workLightsNamei = string.format("vehicle.workLights.workLight" .. "%d", i);
        self.workLights[i] = Utils.indexToObject(self.components, getXMLInt(xmlFile, workLightsNamei .. "#index"));
        setVisibility(self.workLights[i], false);
    end;
  
  -- Ventilator
    self.ventilator = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ventilator#index"));    
    self.ventilatorRotation = 0;

  -- Iluminare Bord
  self.bordIluminat = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.bordIluminat#index"));
	setVisibility(self.bordIluminat,false);
	
  -- Cheie Contact
  self.martor = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.martor#index"));
	
	local translationPartNodeCheieContact = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.CheieContact#index"));
    	if translationPartNodeCheieContact ~= nil then
        self.translationPartCheieContact = {};
        self.translationPartCheieContact.node = translationPartNodeCheieContact;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.CheieContact#minTrans"));
        self.translationPartCheieContact.minTrans = {};
        self.translationPartCheieContact.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartCheieContact.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartCheieContact.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.CheieContact#maxTrans"));
        self.translationPartCheieContact.maxTrans = {};
        self.translationPartCheieContact.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartCheieContact.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartCheieContact.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPartCheieContact.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.CheieContact#transTime"), 2)*1000;
        self.translationPartCheieContact.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.CheieContact#touchTransLimit"), 10);
    end;

	-- Ace bord
	local rotationPartNodeCarburant = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartCarburant#index"));
    if rotationPartNodeCarburant ~= nil then
        self.rotationPartCarburant = {};
        self.rotationPartCarburant.node = rotationPartNodeCarburant;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartCarburant#minRot"));
        self.rotationPartCarburant.minRot = {};
        self.rotationPartCarburant.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartCarburant.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartCarburant.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartCarburant#maxRot"));
        self.rotationPartCarburant.maxRot = {};
        self.rotationPartCarburant.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartCarburant.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartCarburant.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartCarburant.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartCarburant#rotTime"), 50);
        self.rotationPartCarburant.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartCarburant#touchRotLimit"), 10));
    end;
	
	local rotationPartNodePresiuneUlei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#index"));
    if rotationPartNodePresiuneUlei ~= nil then
        self.rotationPartPresiuneUlei = {};
        self.rotationPartPresiuneUlei.node = rotationPartNodePresiuneUlei;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#minRot"));
        self.rotationPartPresiuneUlei.minRot = {};
        self.rotationPartPresiuneUlei.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPresiuneUlei.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPresiuneUlei.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#maxRot"));
        self.rotationPartPresiuneUlei.maxRot = {};
        self.rotationPartPresiuneUlei.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPresiuneUlei.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPresiuneUlei.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartPresiuneUlei.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#rotTime"), 50);
        self.rotationPartPresiuneUlei.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPresiuneUlei#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeTemperaturaApa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#index"));
    if rotationPartNodeTemperaturaApa ~= nil then
        self.rotationPartTemperaturaApa = {};
        self.rotationPartTemperaturaApa.node = rotationPartNodeTemperaturaApa;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#minRot"));
        self.rotationPartTemperaturaApa.minRot = {};
        self.rotationPartTemperaturaApa.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTemperaturaApa.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTemperaturaApa.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#maxRot"));
        self.rotationPartTemperaturaApa.maxRot = {};
        self.rotationPartTemperaturaApa.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTemperaturaApa.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTemperaturaApa.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        
        self.rotationPartTemperaturaApa.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#rotTime"), 200);
        self.rotationPartTemperaturaApa.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTemperaturaApa#touchRotLimit"), 10));
    end;
    
  --Turometru
  	local rotationPartNodeTurometru = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTurometru#index"));
    if rotationPartNodeTurometru ~= nil then
        self.rotationPartTurometru = {};
        self.rotationPartTurometru.node = rotationPartNodeTurometru;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTurometru#minRot"));
        self.rotationPartTurometru.minRot = {};
        self.rotationPartTurometru.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTurometru.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTurometru.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTurometru#maxRot"));
        self.rotationPartTurometru.maxRot = {};
        self.rotationPartTurometru.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTurometru.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTurometru.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        
        self.rotationPartTurometru.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTurometru#rotTime"), 2)*1000;
        self.rotationPartTurometru.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTurometru#touchRotLimit"), 10));
    end;
	
	-- animatie ridicator
	self.lifter = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lifter#index"));
	self.lifterAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lifterAttacher#index"));
	self.lifterArmLower = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lifterArmLower#index"));
	self.lifterArmLowerAttacherJoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lifterArmLowerAttacherJoint#index"));
	self.push1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.push1#index"));
	self.push2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.push2#index"));
	self.hydraulics1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulics1#index"));
	self.hydraulics2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulics2#index"));
	self.hydraulicsJoint1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicsJoint1#index"));
	self.hydraulicsJoint2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hydraulicsJoint2#index"));
	
	-- animatie punte fata
	self.frontAxle = {};
	self.frontAxle.rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#rotNode"));
	self.frontAxle.steeringHydraulicsLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringHydraulicsLeft"));
	self.frontAxle.steeringHydraulicsRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringHydraulicsRight"));
	self.frontAxle.steeringPushLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushLeft"));
	self.frontAxle.steeringPushRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushRight"));
	self.frontAxle.steeringPushLeftAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushLeftAttach"));
	self.frontAxle.steeringPushRightAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#steeringPushRightAttach"));
	self.frontAxle.guidanceRod = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontAxle#guidanceRod"));
	
	self.numAnimatedWheels = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.animatedWheels#count"), 0);
	self.animatedWheel = {};
    for i=1, self.numAnimatedWheels do
        local objname = string.format("vehicle.animatedWheels.wheel" .. "%d", i);
		self.animatedWheel[i] = {};
        self.animatedWheel[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		self.animatedWheel[i].wheel = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#wheelIndex"));
		self.animatedWheel[i].fenderAttach = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#fenderAttach"));
    end;
    
  -- Cardan Directie
  	
	self.numCardanDirectie = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cardanDirectie#count"), 0);
	self.cardanDirectie = {};
    for i=1, self.numCardanDirectie do
        local objname = string.format("vehicle.cardanDirectie.cardan" .. "%d", i);
		self.cardanDirectie[i] = {};
        self.cardanDirectie[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
    end;  
  self.numCardanDirectie1 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cardanDirectie1#count"), 0);
	 self.cardanDirectie1 = {};
    for i=1, self.numCardanDirectie1 do
        local objname = string.format("vehicle.cardanDirectie1.cardan" .. "%d", i);
		self.cardanDirectie1[i] = {};
        self.cardanDirectie1[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
    end;    
	
	-- Camera reglabila
	self.internalCamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.internalCamera#index"));
	
	
	-- manete si intrerupatoare
	self.liftSwitch = {}; 
	self.liftSwitch.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.liftSwitch#index"));
	
	self.liftLeaver = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.liftLeaver#index"));
	self.liftLeaverRelationship = 0;
	if self.attacherJoints[1].maxRot[1] ~= nil and self.attacherJoints[1].minRot[1] ~= nil then
		self.liftLeaverRelationship = (self.attacherJoints[1].minRot[1] - self.attacherJoints[1].maxRot[1])/Utils.degToRad(-8);
	end;
	
	local capotaNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.capota#index"));
    if capotaNode ~= nil then
        self.capota = {};
        self.capota.node = capotaNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.capota#minRot"));
        self.capota.minRot = {};
        self.capota.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.capota.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.capota.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.capota#maxRot"));
        self.capota.maxRot = {};
        self.capota.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.capota.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.capota.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.capota.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.capota#rotTime"), 200);
        self.capota.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.capota#touchRotLimit"), 10));
    end;
    
	local geamNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.geam#index"));
    if geamNode ~= nil then
        self.geam = {};
        self.geam.node = geamNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.geam#minRot"));
        self.geam.minRot = {};
        self.geam.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.geam.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.geam.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.geam#maxRot"));
        self.geam.maxRot = {};
        self.geam.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.geam.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.geam.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.geam.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.geam#rotTime"), 200);
        self.geam.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.geam#touchRotLimit"), 10));
    end;      

	local usaNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.usa#index"));
    if usaNode ~= nil then
        self.usa = {};
        self.usa.node = usaNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.usa#minRot"));
        self.usa.minRot = {};
        self.usa.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.usa.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.usa.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.usa#maxRot"));
        self.usa.maxRot = {};
        self.usa.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.usa.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.usa.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.usa.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.usa#rotTime"), 200);
        self.usa.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.usa#touchRotLimit"), 10));
    end;    
    
	
	local CapacRezervorNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.CapacRezervor#index"));
    if CapacRezervorNode ~= nil then
        self.CapacRezervor = {};
        self.CapacRezervor.node = CapacRezervorNode;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.CapacRezervor#minRot"));
        self.CapacRezervor.minRot = {};
        self.CapacRezervor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.CapacRezervor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.CapacRezervor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.CapacRezervor#maxRot"));
        self.CapacRezervor.maxRot = {};
        self.CapacRezervor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.CapacRezervor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.CapacRezervor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.CapacRezervor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.CapacRezervor#rotTime"), 200);
        self.CapacRezervor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.CapacRezervor#touchRotLimit"), 10));
    end;
	
	self.tirant = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tirant#index"));
	self.cupla = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.cupla#index"));
 	setVisibility((self.tirant), true);
 	setVisibility((self.cupla), false);

	
	self.lightSwitch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lightSwitch#index"));
	self.key = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.key#index"));
	self.engineRunTime = 0;	

	self.frontLightMode = 0;
	self.headLightActive = false;
	self.frontWorkLightActive = false;
	self.workLightActive = false;
	self.martorActive = false;
	self.semnalizare = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.semnalizare#index"));
	
	self.prevousFuelPercentage = 0;
	
	self.cycleRoundMax = 30;
	self.currentCycle = 0;
	self.lastRpm = 0;
	
	self.lifterStartAngle = 0;
	
	self.startAngel1 = 0;
	self.startAngel2 = 0;
	self.startTranslation = 0;
	self.liftInitialized = false;
	self.shiftMode = 1;
	self.lastLiftXRot = 0;
	self.mirrorsEnabled = false;
	self.leftMirrorGlass = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.leftMirrorGlass#index"));
	self.rightMirrorGlass = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rightMirrorGlass#index"));	
	
	if self.camPositionX == nil then
		self.camPositionX = 0;
	end;
	
	if self.camPositionZ == nil then
		self.camPositionZ = 0;
	end;

end;


      
function utb650M:delete()
end;

function utb650M:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function utb650M:keyEvent(unicode, sym, modifier, isDown)
  if isDown and sym == Input.KEY_down then
		self.translationMaxCheieContact = not self.translationMaxCheieContact;
		self.martorActive = not self.martorActive;
	end;
end;

function utb650M:update(dt)
	if self.isMotorStarted then
		self.ventilatorRotation =	self.ventilatorRotation + 30;
		setRotation(self.ventilator, 0, Utils.degToRad(self.ventilatorRotation), 0);
		self.engineRunTime = dt + self.engineRunTime;
		self.martorActive = false;
		self.translationMaxCheieContact = true;
	else
		self.engineRunTime = 0;
		self.translationMaxCheieContact = false;
	end; 
	
if self.inrange or self.isEntered then
	if InputBinding.hasEvent (InputBinding.DESCHIDEUSA) then
		self.openUsa = not self.openUsa;
	end;
	if InputBinding.hasEvent (InputBinding.DESCHIDECAPOTA) then
		self.openCapota = not self.openCapota;
	end;
end;

	if self.inrange or self.isEntered then
		if self.openUsa then
		 	g_currentMission:addExtraPrintText(string.format("Taste %s: inchide usa", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DESCHIDEUSA))); 	
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: deschide usa", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DESCHIDEUSA)));
		end;

		if self.openCapota then
			g_currentMission:addExtraPrintText(string.format("Taste %s: inchide capota", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DESCHIDECAPOTA)));
		else
			g_currentMission:addExtraPrintText(string.format("Taste %s: deschide capota", InputBinding.getKeyNamesOfDigitalAction(InputBinding.DESCHIDECAPOTA)));
		end;
	end; 
	
 if self.isEntered then		
      g_currentMission:addExtraPrintText(string.format("Taste %s: porneste/opreste motorul", InputBinding.getKeyNamesOfDigitalAction(InputBinding.JDTIGNITION))); 
 end;
 	
	--Cheie Contact	
	if self.translationPartCheieContact ~= nil then 
		local x, y, z = getTranslation(self.translationPartCheieContact.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPartCheieContact.maxTrans, self.translationPartCheieContact.minTrans, 3, self.translationPartCheieContact.transTime, dt, not self.translationMaxCheieContact); 
		setTranslation(self.translationPartCheieContact.node, unpack(newTrans)); 
	end;
	setVisibility(self.martor, self.martorActive);
  		
	-- Ace bord
	if self.isMotorStarted then
		if self.rotationPartCarburant ~= nil then
			local x, y, z = getRotation(self.rotationPartCarburant.node);
			z = ((self.rotationPartCarburant.maxRot[3] - self.rotationPartCarburant.minRot[3]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartCarburant.minRot[3];
			setRotation(self.rotationPartCarburant.node, x, y ,z);
		end;
			
		if self.rotationPartPresiuneUlei ~= nil then
			setRotation(self.rotationPartPresiuneUlei.node, 0, 0, Utils.degToRad(-50));
		end; 
		
	if self.rotationPartTemperaturaApa ~= nil then
		local x, y, z = getRotation(self.rotationPartTemperaturaApa.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartTemperaturaApa.minRot, self.rotationPartTemperaturaApa.maxRot, 3, self.rotationPartTemperaturaApa.rotTime, dt, 1);
		setRotation(self.rotationPartTemperaturaApa.node, unpack(newRot));
	end;		
		
	else
		setRotation(self.rotationPartCarburant.node, 0, 0 , 0);
		setRotation(self.rotationPartPresiuneUlei.node, 0, 0 , 0);
		setRotation(self.rotationPartTemperaturaApa.node, 0, 0 , 0);
	end;
	
	--Turometru
		if self.isMotorStarted then
			if self.currentCycle < self.cycleRoundMax then
				self.currentCycle = self.currentCycle + 1;
				self.currentRPM = self.motor.lastMotorRpm;
				if self.rpmMeterValue ~= nil then
					self.currentRPM = self.rpmMeterValue;
				end;
				self.lastRpm = math.floor((self.lastRpm + self.currentRPM)/2);
		end;
	if self.isMotorStarted then
		if self.rotationPartTurometru ~= nil then
			local x, y, z = getRotation(self.rotationPartTurometru.node);
			z = ((self.rotationPartTurometru.maxRot[3] - self.rotationPartTurometru.minRot[3]) / 2900) * 	self.rpmMeterValue + self.rotationPartTurometru.minRot[3];
			setRotation(self.rotationPartTurometru.node, x, y ,z);
		end;
	else
		setRotation(self.rotationPartTurometru.node, 0, 0 , 0);
	 end;
  end;	
		
	-- Animatii punte fata
	if self.attacherJoints[1] ~= nil then
		if self.attacherJoints[1].maxRot[1] ~= nil then
			if not self.liftInitialized then
				self.maxLiftDebth = self.attacherJoints[1].maxRot[1];
				self.minLiftDebth = self.attacherJoints[1].minRot[1];
				self.liftInitialized = true;
			end;
		end;
	end;  
				
	if self.frontAxle.rotNode ~= nil and self.wheels[1].repr ~= nil and self.wheels[2].repr ~= nil then
		local ax, ay, az = getWorldTranslation(self.wheels[1].repr);
        local bx, by, bz = getWorldTranslation(self.wheels[2].repr);
		
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.rotNode), bx-ax, by-ay, bz-az);
		
        setDirection(self.frontAxle.rotNode, x, y, z, 1, 0, 1);
		
		local x2,y2,z2 = getRotation(self.frontAxle.rotNode);
		setRotation(self.frontAxle.rotNode,x2 - 1.571,y2,z2 + 1.571);
	end;
	
	for i=1, self.numAnimatedWheels do
		if self.wheels[i].repr ~= nil then
			local x,y,z = getRotation(self.wheels[i].driveNode);
			local x2,y2,z2 = getRotation(self.wheels[i].repr);
			setRotation(self.animatedWheel[i].wheel, x,y,z);
			setRotation(self.animatedWheel[i].rotNode, x2,y2,z2);
		end;
	end;

	
	if self.frontAxle.steeringHydraulicsLeft ~= nil and self.frontAxle.steeringPushLeftAttach ~= nil then
		local ax, ay, az = getWorldTranslation(self.frontAxle.steeringHydraulicsLeft);
        local bx, by, bz = getWorldTranslation(self.frontAxle.steeringPushLeftAttach);

		
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.steeringHydraulicsLeft), bx-ax, by-ay, bz-az);
        setDirection(self.frontAxle.steeringHydraulicsLeft, x, y, z, 0, -1, 0);
		
		local x,y,z = getRotation(self.animatedWheel[1].rotNode);
		self.translation = -0.17 * math.tan(y);
		setTranslation(self.frontAxle.steeringPushLeft,(self.translation)*0.7,0,0);	
	end;
	
	if self.frontAxle.steeringHydraulicsRight ~= nil and self.frontAxle.steeringPushRightAttach ~= nil then
		local ax, ay, az = getWorldTranslation(self.frontAxle.steeringPushRightAttach);
        local bx, by, bz = getWorldTranslation(self.frontAxle.steeringHydraulicsRight);

		
		local x, y, z = worldDirectionToLocal(getParent(self.frontAxle.steeringHydraulicsRight), bx-ax, by-ay, bz-az);
        setDirection(self.frontAxle.steeringHydraulicsRight, x, y, z, 0, 1, 0);
		
		local x,y,z = getRotation(self.animatedWheel[2].rotNode);
		self.translation = 0.17 * math.tan(y);
		setTranslation(self.frontAxle.steeringPushRight,(self.translation)*0.7,0,0);
	end;
	
	if self.animatedWheel[1].fenderAttach ~= nil and self.animatedWheel[2].fenderAttach ~= nil then
		local ax, ay, az = getWorldTranslation(self.animatedWheel[1].fenderAttach);
        local bx, by, bz = getWorldTranslation(self.animatedWheel[2].fenderAttach);
		
		local x, y, z = worldDirectionToLocal(getParent(self.animatedWheel[2].fenderAttach), bx-ax, by-ay, bz-az);
        setDirection(self.animatedWheel[1].fenderAttach, x, y, z, 0, 1, 0);
		
	end;
	
	-- Cardan Directie
	
	for i=1, self.numCardanDirectie do
		if self.wheels[i].repr ~= nil then
		local x2,y2,z2 = getRotation(self.wheels[i].repr);
		setRotation(self.cardanDirectie[i].rotNode, x2,y2 * 17.14,z2);
		end;
	end;
	for i=1, self.numCardanDirectie1 do
		if self.wheels[i].repr ~= nil then
		local x2,y2,z2 = getRotation(self.wheels[i].repr);
		setRotation(self.cardanDirectie1[i].rotNode, x2,y2 * 17.14,z2);
		end;
	end;

	
	-- Animatii ridicator
	if self.lifterArmLower ~= nil and self.lifter ~= nil then
		local x,y,z = getRotation(self.lifterArmLower);
		if self.lifterStartAngle == 0 and x ~= nil then
			self.lifterStartAngle = x;
		end;
		
		local lifterFactor = 1.99;
		local lifterRotation =  x * lifterFactor ;
		setRotation(self.lifter, lifterRotation, y,z);
		
		if self.lifterAttacher ~= nil and self.lifterArmLowerAttacherJoint ~= nil then
			local ax, ay, az = getWorldTranslation(self.lifterAttacher);
			local bx, by, bz = getWorldTranslation(self.lifterArmLowerAttacherJoint);

			local x, y, z = worldDirectionToLocal(getParent(self.lifterAttacher), bx-ax, by-ay, bz-az);
			setDirection(self.lifterAttacher, x, y, z, 0, 1, 0);		
		end;
	end;
	
	if self.hydraulicsJoint1 ~= nil and self.hydraulics1 ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulics1);
        local bx, by, bz = getWorldTranslation(self.hydraulicsJoint1);

        local x, y, z = worldDirectionToLocal(getParent(self.hydraulics1), bx-ax, by-ay, bz-az);
        setDirection(self.hydraulics1, x, y, z, 0, 1, 0);
		local xFactor = 1;
		if self.lifterArmLower ~= nil then
			local x,y,z = getRotation(self.lifterArmLower);
			local startX = (9/180) * 3.14;
			
			xFactor = 0.152 * (startX-x);
		end;
		
		local xTransLation = math.sqrt((bx-ax)^2 + (by-ay)^2 + (bz-az)^2);
		
		setTranslation(self.push1,xTransLation + xFactor,0,0);
		
		local x2,y2,z2 = getRotation(self.hydraulics1);
		setRotation(self.hydraulics1,x2, y2+1.57,z2);
	end;
	
	if self.hydraulicsJoint2 ~= nil and self.hydraulics2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulics2);
        local bx, by, bz = getWorldTranslation(self.hydraulicsJoint2);

        local x, y, z = worldDirectionToLocal(getParent(self.hydraulics2), bx-ax, by-ay, bz-az);
        setDirection(self.hydraulics2, x, y, z, 0, 1, 0);
		
		local xFactor = 1;
		if self.lifterArmLower ~= nil then
			local x,y,z = getRotation(self.lifterArmLower);
			local startX = (9/180) * 3.14;
			
			xFactor = 0.152 * (startX-x);
		end;
		
		local xTransLation = math.sqrt((bx-ax)^2 + (by-ay)^2 + (bz-az)^2);
		
		setTranslation(self.push2,xTransLation + xFactor,0,0);
		
		local x2,y2,z2 = getRotation(self.hydraulics2);
		setRotation(self.hydraulics2,x2, y2+1.57,z2);
	end;
	
	if self.capota ~= nil then
		local x, y, z = getRotation(self.capota.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.capota.minRot, self.capota.maxRot, 3, self.capota.rotTime, dt, self.openCapota);
		setRotation(self.capota.node, unpack(newRot));
	end;

	if self.usa ~= nil then
		local x, y, z = getRotation(self.usa.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.usa.minRot, self.usa.maxRot, 3, self.usa.rotTime, dt, self.openUsa);
		setRotation(self.usa.node, unpack(newRot));
	end;
  
	if self.geam ~= nil then
		local x, y, z = getRotation(self.geam.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.geam.minRot, self.geam.maxRot, 3, self.geam.rotTime, dt, self.openGeam);
		setRotation(self.geam.node, unpack(newRot));
	end;  	

	if self.CapacRezervor ~= nil then
		local x, y, z = getRotation(self.CapacRezervor.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.CapacRezervor.minRot, self.CapacRezervor.maxRot, 3, self.CapacRezervor.rotTime, dt, self.openCapacRezervor);
		setRotation(self.CapacRezervor.node, unpack(newRot));
	end;

	-- Key animation
	if self.key ~= nil then
		if self.isMotorStarted and self.engineRunTime < 1500 then
			setRotation(self.key, Utils.degToRad(-74.51489),Utils.degToRad(-29.51921) ,Utils.degToRad(60.65189));
		elseif self.isMotorStarted then
			setRotation(self.key, Utils.degToRad(-60.11575),Utils.degToRad(-14.71329) ,Utils.degToRad(23.84418));
		else
			setRotation(self.key, Utils.degToRad(-57.08946),Utils.degToRad(2.67945) ,Utils.degToRad(-4.13145));
		end;
	end;
	
function utb650M:updateTick(dt)

if g_currentMission.player ~= nil then
		-- Getting the distance between the player and the implement 
		local nearestDistance = 4.0; --max distance allowed
		local px, py, pz = getWorldTranslation(self.rootNode); 
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance < nearestDistance then
			self.inrange = true; 
		else
			self.inrange = false; 
		end;
	end;
end;

	-- Input reading
	if self.isEntered then
		if InputBinding.hasEvent(InputBinding.LIGHTSCYCLE) then
			self.frontLightMode = self.frontLightMode + 1;
			if self.frontLightMode > 5 then
				self.frontLightMode = 0;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMLEFT) then
			if 	self.shiftMode == 1 then
				self.camPositionX = self.camPositionX + 0.02;
				if self.camPositionX >= 0.3 then
					self.camPositionX = 0.3;
				end;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMRIGHT) then
			if 	self.shiftMode == 1 then
				self.camPositionX = self.camPositionX - 0.02;
				if self.camPositionX <= -0.3 then
					self.camPositionX = -0.3;
				end;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMFORWARD) then
			if 	self.shiftMode == 1 then
				self.camPositionZ = self.camPositionZ + 0.02;
				if self.camPositionZ >= 0.3 then
					self.camPositionZ = 0.3;
				end;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.MOVECAMBACK) then
			if 	self.shiftMode == 1 then
				self.camPositionZ = self.camPositionZ - 0.02;
				if self.camPositionZ <= -0.3 then
					self.camPositionZ = -0.3;
				end;
			end;
		end;
		
		if InputBinding.hasEvent(InputBinding.MOVECAMRESET) then
			if 	self.shiftMode == 1 then
				self.camPositionX = 0;
				self.camPositionZ = 0;
			end;
		end;
		
		if InputBinding.hasEvent(InputBinding.DESCHIDEREZERVOR) then
			self.openCapacRezervor = not self.openCapacRezervor;
		end;
	

		if InputBinding.hasEvent(InputBinding.DESCHIDEGEAMUL) then
			self.openGeam = not self.openGeam;
		end;    		
		
		if InputBinding.isPressed(InputBinding.JDINCREASELIFTDEBTH) then
			if self.attacherJoints[1] ~= nil then
				if self.attacherJoints[1].maxRot[1] ~= nil then
					if self.attacherJoints[1].maxRot[1] > self.maxLiftDebth then
						self.attacherJoints[1].maxRot[1] = self.attacherJoints[1].maxRot[1] - 0.005;
					end;
				end;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.JDDECRESELIFTDEBTH) then
			if self.attacherJoints[1] ~= nil then
				if self.attacherJoints[1].maxRot[1] ~= nil then
					if self.attacherJoints[1].maxRot[1] < self.minLiftDebth then
						self.attacherJoints[1].maxRot[1] = self.attacherJoints[1].maxRot[1] + 0.005;
					end;
				end;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.JDINCREASELIFTROT) then
			if self.attacherJoints[1] ~= nil then
				if self.attacherJoints[1].maxRot2[1] ~= nil and self.attacherJoints[1].maxRot2[1] > 0.0 then
					self.attacherJoints[1].maxRot2[1] = self.attacherJoints[1].maxRot2[1] - 0.005;
					self.attacherJoints[1].minRot2[1] = self.attacherJoints[1].minRot2[1] - 0.005;
				end;
			end;
		end;
		
		if InputBinding.isPressed(InputBinding.JDDECRESELIFTROT) then
			if self.attacherJoints[1] ~= nil then
				if self.attacherJoints[1].maxRot2[1] ~= nil and self.attacherJoints[1].maxRot2[1] < 0.3 then
					self.attacherJoints[1].maxRot2[1] = self.attacherJoints[1].maxRot2[1] + 0.005;
					self.attacherJoints[1].minRot2[1] = self.attacherJoints[1].minRot2[1] + 0.005;
				end;
			end;
		end;
	end;
		
    if InputBinding.hasEvent(InputBinding.ACTIVATEMIRRORS) then
			self.mirrorsEnabled = not self.mirrorsEnabled;
		end;
     
	if self.leftMirrorGlass ~= nil then
		setVisibility(self.leftMirrorGlass,self.mirrorsEnabled);
	end;
	
	if self.rightMirrorGlass ~= nil then
		setVisibility(self.rightMirrorGlass,self.mirrorsEnabled);
	end;
  	
	-- manete si intrerupatoare
	
	if self.attacherJoints[1].rotationNode ~= nil then
		
		--renderText(0.5, 0.42, 0.020, string.format("min rot=" .. "%f", self.attacherJoints[1].minRot[1]));
		--renderText(0.5, 0.40, 0.020, string.format("max rot=" .. "%f", self.attacherJoints[1].maxRot[1]));
		--renderText(0.5, 0.38, 0.020, string.format("current rot=" .. "%f", x));
		--renderText(0.5, 0.36, 0.020, string.format("self.liftLeaverRelationship=" .. "%f", self.liftLeaverRelationship));
		
		
		local x,y,z = getRotation(self.attacherJoints[1].rotationNode);
		if x < self.lastLiftXRot then
			setRotation(self.liftSwitch.node, Utils.degToRad(10), 0, 0);
		elseif x > self.lastLiftXRot then
			setRotation(self.liftSwitch.node, Utils.degToRad(-10), 0, 0);
		end;
		self.lastLiftXRot = x; 
	end;
		
	if self.liftLeaver ~= nil then
		setRotation(self.liftLeaver, (self.attacherJoints[1].maxRot[1] * self.liftLeaverRelationship), 0 ,0);
	end;
	
	-- Camera translation
	if self.internalCamera ~= nil then
		setTranslation(self.internalCamera, self.camPositionX, 0, self.camPositionZ);
	end;
	
	-- lights
	if self.frontLightMode == 0  then
		self.headLightActive = false;
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(0), 0);
		end;
	elseif self.frontLightMode == 1 or self.frontLightMode == 5 then
		self.headLightActive = true;
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(30), 0);
		end;
	elseif self.frontLightMode == 2 or self.frontLightMode == 4 then
		self.headLightActive = true;
		self.workLightActive = false;
		self.frontWorkLightActive = true;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(60), 0);
		end;
	elseif self.frontLightMode == 3 then
		self.headLightActive = true;
		self.workLightActive = true;
		self.frontWorkLightActive = true;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, 0, Utils.degToRad(90), 0);
		end;
	end;
	
	if self.frontLightMode == 0 then
		setVisibility(self.bordIluminat,false);
	else
		setVisibility(self.bordIluminat,true);
	end;
	
	if not self.isMotorStarted then
		setVisibility(self.bordIluminat,false);
	end;
	
	for i=1, self.numHeadLights do
		setVisibility(self.headLights[i], self.headLightActive);
	end;
	
	for i=1, self.numFrontWorkLights do
		setVisibility(self.frontWorkLights[i], self.frontWorkLightActive);
	end;
	
	for i=1, self.numWorkLights do
		setVisibility(self.workLights[i], self.workLightActive);
	end;
	
end;

function utb650M:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	self.camPositionX = Utils.getNoNil(getXMLFloat(xmlFile, key.."#camPositionX"), 0);
	self.camPositionZ = Utils.getNoNil(getXMLFloat(xmlFile, key.."#camPositionZ"), 0);
end;

function utb650M:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'camPositionX="'..self.camPositionX..'" camPositionZ="'..self.camPositionZ..'"';
    return attributes, nil;
end;
function utb650M:attachImplement(implement)	
	local jointType = implement.object.attacherJoint.jointType;
	local jointIndex = implement.jointDescIndex;
	
	if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
			if jointIndex == 1 then
			setVisibility((self.tirant), true);
			setVisibility((self.cupla), false);			
			end;
	end;

	if jointType == Vehicle.JOINTTYPE_TRAILER then
		if jointIndex == 2 then
			setVisibility((self.tirant), false);
			setVisibility((self.cupla), true);
		end;
	end;
	self.updateJoint = true;	
end;
function utb650M:detachImplement(implementIndex)

	local implement = self.attachedImplements[implementIndex];
	local jointIndex = implement.jointDescIndex;
	
	if jointIndex == 1 or jointIndex == 3 then
		setVisibility((self.tirant), false);
		setVisibility((self.cupla), true);
	end;
	if jointIndex == 2 then
		setVisibility((self.tirant), false);
		setVisibility((self.cupla), true);
	end

end;

function utb650M:validateAttacherJoint(implement, jointDesc, dt)
        return true;
end;

function utb650M:onLeave()
end;

function utb650M:draw()
end;
